; File Name   :	V24G.bin
; Format      :	Binary file
; Base Address:	0000h Range: BB00h - C000h Loaded length: 0500h

; ASGN-kompatibler Treiber fr V24-Drucker am Userport
; 9600 Baud, 8 Bit, 1 Stoppbit, EPSON-kompatibel
; 
; Der Code basiert auf dem Beitrag in der	MP 
; und wurde um Vollgrafik erweitert
; 
; reass: V.Pohlers 29.08.2008, letzte nderung 29.08.2008

		cpu	Z80

		org 	0BB00h
		jp	init

aV24g:		db "V24G    ",0
		db    0

init:		ld	a, 0CFh	   	; BIT-E/A
		out	(8Bh), a
		ld	a, 80h 	    	; nur Bit 7 Eing.
		out	(8Bh), a
		cpl
		out	(89h), a
		ld	hl, esc_init	; ESC-Initialsierungssequenz
		ld	b, 5
		call	outstr		; Ausgabe von B	Zeichen	ab (HL)
		ld	bc, ttyl	; TTY-Treiber
		ld	de, aV24g	; "V24G	   "
		ld	hl, 602h	; LIST:, phys.Ger.2
		ret

; TTY-Treiber
ttyl:		inc	a		
		ret	z		; FF-initialisieren (wird ignoriert)
		dec	a		; Drucker-Status (A=0)?
		jr	nz, chout	; Zeichenausgabe

; Status-Abfrage
stat:		in	a, (89h)	; Status
		or	7Fh
		cpl
		or	a
		ret

chout:		ld	a, c		; Zeichenausgabe
		cp	0Eh		; Bildschirmkopie?
		jr	nz, dout	; nein - Zeichen ausgeben

; Bildschirmkopie
		ld	bc, 3C0h
		ld	hl, 0EC00h
		ld	d, 40
bws1:		ld	a, (hl)
		push	bc
		cp	' '
		jr	nc, bws2
		ld	a, ' '
bws2:		ld	c, a
		push	hl
		call	dout
		pop	hl
		pop	bc
		dec	d
		jr	nz, bws3
		push	bc
		ld	c, 0Dh
		call	PSOUT		; phys.	Zeichenausgabe von C
		ld	c, 0Ah
		call	PSOUT		; phys.	Zeichenausgabe von C
		pop	bc
		ld	d, 40
bws3:		cpi
		ret	po
		jr	bws1

; Zeichenausgabe
dout:		bit	7, c
		jr	z, PSOUT	; phys.	Zeichenausgabe von C

; Zeichen >=80h	im Grafikmodus ausgeben
		ld	hl, escs	; ESC-Codes fr	Grafikdruck
		push	bc
		ld	b, 5
		call	outstr		; Ausgabe von B	Zeichen	ab (HL)
		pop	bc
		ld	hl, chrtab
		xor	a
		sla	c
		sla	c
		rla
		sla	c
		rla
		ld	b, a		; BC :=	(char -80h) * 8
		add	hl, bc
		ld	b, 8		; 8 Spalten pro	Grafikzeichen drucken

; Ausgabe von B	Zeichen	ab (HL)
outstr:		ld	c, (hl)
		push	bc
		call	PSOUT		; phys.	Zeichenausgabe von C
		pop	bc
		inc	hl
		djnz	outstr		; Ausgabe von B	Zeichen	ab (HL)
		ret

; phys.	Zeichenausgabe von C
; Parallel-Serien Wandlung und Ausgabe (s. MP)
PSOUT:		call	stat		; Status-Abfrage
		jr	z, PSOUT	; nein,	warten
		ld	a, c		; Zeichen nach A
		ld	bc, 90Ch	; 9 Bit, Zeitkonstante 12 = 9600 Baud
		rla
		di
cout2:		out	(89h), a	; Bit ausgeben
		call	wait		; eine Bit-Zeit	warten
		rra			; naechstes Bit
		djnz	cout2
		or	1		; Stopbit
		out	(89h), a
		ei
;
wait:		push	bc
wait1:		dec	c
		jr	nz, wait1
		pop	bc
		ret

; ESC-Codes fr	Grafikdruck
escs:		db  1Bh
		db '*'
		db    4
		db    8
		db    0
; ESC-Initialsierungssequenz
esc_init:	db  1Bh
		db '3'                  ; Zeilenabstand 18h/216"
		db  18h
		db  1Bh			; pica width (10 cpi)
		db 'P'

chrtab:		equ	$

		; der Z9001-Zeichensatz (nur Grafikzeichen), 8x8 Punkte
		include	zsatz_v24G.inc

		end
